namespace de.osci.helper {

	using System;

	/// <summary><p> Wrapper zum Base64-Ver-/Entschlsseln kleinerer Datenmengen.</p>
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class Base64 {
		private const int bufferSize=4096;
		public Base64() {}

		public static string encode(String s) 
		{
			byte[] binaryData=SupportClass.ToByteArray(s);
			return encode (binaryData);
		}
		
		public static string encode(String s, String encoding) 
		{
			byte[] binaryData=MoreSupport.ToByteArray(s,encoding);
			return encode (binaryData);
		}

		public static string encode(byte[] binaryData) 
		{
            String b64 = Convert.ToBase64String(binaryData,0,binaryData.Length);
            String ret = "";
            int i = 0;
            while (i + 76 < b64.Length)
            {
                ret += b64.Substring(i, 76) + "\n";
                i += 76;
            }
            ret += b64.Substring(i, b64.Length - i);
            return ret;
		}

		public static byte[] decode(string data) 
		{
			return Convert.FromBase64String(data);
		}

		public static long calcB64Length(long len)
		{
			if (len == 0)
				return 0;
			long l = ((len-1) / 3 * 4) + 4;
			return l + (l/76);
		}
	}
}
