namespace de.osci.helper {

	using	System;
	using	de.osci.osci12.common;
	
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class MIMEPartInputStream:de.osci.osci12.dotcommon.InputStream {
		virtual public	String ContentID {
			get {
				return contentID;
			}
		}
        virtual public long Length
        {
			get {
				return contentLength;
			}
		}
		public String	contentType;
		public String	encoding;
		private String	contentID;
		private int	s,	count=0;
		private long	contentLength;
		private bool closed = false;
		private byte[]	end;
		private MIMEParser parser;
		public System.Collections.Hashtable mime_headers;
		
		public MIMEPartInputStream(MIMEParser parser, String contentType,	String encoding, String	contentID, long	contentLength)	{
			this.parser	= parser;
			this.end	= SupportClass.encoder.GetBytes("\r\n--" + parser.boundary);
			this.contentType = contentType;
			this.encoding = encoding;
			this.contentID	= contentID;
			this.contentLength =	contentLength;
		}

		public override int Read(byte[] b, int	off, int	len) {
			if	(closed)
				return 0;
			if	(parser.buffer	!=	null)	{
				if	((parser.bufferPointer + len)	<= parser.buffer.Length)	{
					Array.Copy(parser.buffer, parser.bufferPointer,	b,	off, len);
					parser.bufferPointer	+=	len;
					s = len;
				} else {
					int bufBytes =	parser.buffer.Length	- parser.bufferPointer;
					Array.Copy(parser.buffer, parser.bufferPointer,	b,	off, bufBytes);

					s = SupportClass.ReadInput((System.IO.Stream) parser.in_Renamed, ref	b,	off +	bufBytes, len - bufBytes);
					if	
						(s==-1) s=bufBytes;
					else
						s += bufBytes;

					parser.buffer = null;
					parser.bufferPointer	= 0;
				}
			} 
			else {
				s = SupportClass.ReadInput((System.IO.Stream) parser.in_Renamed, ref	b,	off, len);
				if	(s	==	-1) s	= 0;
			}
			
			if	(s	==	0) {
				closed =	true;
			} else {
				int i	= off;
				int patternIndex = -	1;
				int tmp;
				
				for (i =	off; i <	off+s; i++) {
					if	((b[i] == end[0])) {
						for (tmp	= i, patternIndex	= 0; ((patternIndex < end.Length) && (tmp	< (off +	s)));	patternIndex++, tmp++) {
							if	(b[tmp] != end[patternIndex])
								break;
						}
						
						if	(patternIndex == end.Length) {
							// Falls keine Daten im Buffer waren, restliche Daten in neuem Buffer speichern,
							// sonst den bufferPointer zurcksetzen.
							if (parser.buffer == null) {
								parser.buffer = new byte[s	- i +	off];
								Array.Copy(b, i, parser.buffer, 0, parser.buffer.Length);
								parser.bufferPointer	= 0;
							}
							else parser.bufferPointer -= len - (i-off);
							s = i	- off;
							closed =	true;

							break;
						} 
						else if (tmp >= (off	+ s)) {
							int rest = end.Length - patternIndex; 
							if ((parser.buffer == null) || ((parser.buffer.Length - parser.bufferPointer) < rest))
							{
								int bufferIndex = 0; 
								if (parser.buffer == null) 
									parser.buffer = new byte[rest]; 
								else 
								{ 
									// Buffer erweitern, falls notwendig 
									//bufferIndex = parser.bufferPointer;
									bufferIndex = parser.buffer.Length-parser.bufferPointer; 
									//if (parser.buffer.Length - parser.bufferPointer	< rest) { 
									byte[] newBuffer = new byte[rest]; 
									Array.Copy(parser.buffer, parser.bufferPointer, newBuffer, 0, parser.buffer.Length-parser.bufferPointer); 
									parser.buffer = newBuffer; 
									//} 
								} 
							
 
								int p = 0;
								while (bufferIndex < parser.buffer.Length) 
								{
									if ((p = parser.in_Renamed.Read(parser.buffer, bufferIndex, 1)) > 0)
										bufferIndex++;
									else
										throw new System.IO.IOException("EOS before marker.");
								}
								parser.bufferPointer	= 0;
							}	
							for (tmp = parser.bufferPointer; patternIndex < end.Length; patternIndex++, tmp++)							
							{
								if	(parser.buffer[tmp] != end[patternIndex])
									break;
							}
							
						if	(patternIndex == end.Length) {
								s = i - off;
							//	parser.buffer = new byte[end.Length];
							//	System.Array.Copy(end, 0, parser.buffer, 0, end.Length);
							byte[] newBuffer = new byte[(end.Length + parser.buffer.Length) - tmp]; 
							System.Array.Copy(end, 0, newBuffer, 0, end.Length); 
							System.Array.Copy(parser.buffer, tmp, newBuffer, end.Length, parser.buffer.Length - tmp); 
							parser.buffer = newBuffer; 
							parser.bufferPointer = 0;
								//            parser.buffer = null;
									closed =	true;
							}
						}
					}
					
					patternIndex =	0;
				}
			}
			count	+=	s;
			return s;
		}
		
		public override void	 Close()	{
			//	Bis zum Ende lesen....
			byte[] tmp = new byte[1024];
			
			while	(SupportClass.ReadInput(this,	ref tmp,	0,	tmp.Length)	> 0) {
			}
			closed =	true;
		}
	}
}