namespace de.osci.osci12.common
{
	using System;

	/// <summary> <p>In dieser Klasse sind Konstanten der Bibliothek definiert.</p>
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class Constants
	{

		/// <summary> Hashtable mit den bentigten JCA/JCE-Identifiern
		/// </summary>
		public static System.Collections.Hashtable NET_MAP;
		
		/// <summary> Character-Encoding
		/// </summary>
		public const System.String CHAR_ENCODING = "UTF-8";
		
		/// <summary> Algorithmus fr Zufallszahlenerstellung wird auf SHA1 Pseudo Random Number Generation gestellt
		/// </summary>
		public const System.String SECURE_RANDOM_ALGORITHM_SHA1 = "SHA1PRNG";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA1withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA1 = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA1withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA1_NET = "SHA1";  	 

        /// <summary>Hashtable mit Ablaufdaten der Algorithmen und Schlssellngen
        /// </summary>
        public static System.Collections.Hashtable OUT_DATES = new System.Collections.Hashtable();

        /// <summary>Ablaufdatum fr 1024 Bit RSA-Schlssellnge
        /// </summary>
        public static DateTime OUT_DATE_KEYSIZE_1024 = new DateTime(2008, 7, 1);

        /// <summary>Default-Gltigkeitsdatum fr Algorithmusprfungen
        /// </summary>
        public static DateTime ACTUAL_DATE = new DateTime(2011, 7, 1);

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA256 = "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA256_NET = "SHA256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_SHA512 = "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_SHA512_NET = "SHA512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSAandMGF1 (PSS)
        /// </summary>
  	    public const String SIGNATURE_ALGORITHM_RSA_SHA256_PSS = "http://www.w3.org/2007/05/xmldsig-more#sha256-rsa-MGF1";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withRSAandMGF1 (PSS), RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_RSA_SHA256_PSS_NET = "SHA256withRSAandMGF1";
  	 
  	    /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSAandMGF1 (PSS)
        /// </summary>
  	    public const String SIGNATURE_ALGORITHM_RSA_SHA512_PSS = "http://www.w3.org/2007/05/xmldsig-more#sha512-rsa-MGF1";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withRSAandMGF1 (PSS), RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_RSA_SHA512_PSS_NET = "SHA512withRSAandMGF1";
 
        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr RIPEMD160withRSA
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160_RFC4051 = "http://www.w3.org/2001/04/xmldsig-more/rsa-ripemd160";

        /// <summary> Fr Abwrtskompatibilitt nach Korrektur der Konstante fr RIPEMD160withRSA (Version 1.5, typo in RFC 4051)
        /// </summary>
        public const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160 = "http://www.w3.org/2001/04/xmldsig-more#rsa-ripemd160";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr RIPEMD160withRSA, RSAManaged-Identifier
        /// </summary>
        private const System.String SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET = "RIPEMD160";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withECDSA
        /// </summary>
        public const String SIGNATURE_ALGORITHM_ECDSA_SHA256 = "http://www.w3.org/2001/04/xmldsig-more#ecdsa-sha256";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA256withECDSA, RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_ECDSA_SHA256_NET = "SHA256withECDSA";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withECDSA
        /// </summary>
        public const String SIGNATURE_ALGORITHM_ECDSA_SHA512 = "http://www.w3.org/2001/04/xmldsig-more#ecdsa-sha512";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr SHA512withECDSA, RSAManaged-Identifier
        /// </summary>
        private const String SIGNATURE_ALGORITHM_ECDSA_SHA512_NET = "SHA512withECDSA";

        /// <summary> Algorithmus fr Signaturerstellung, Konstante fr Bas64-encoding
		/// </summary>
		public const System.String BASE64_DECODER = "http://www.w3.org/2000/09/xmldsig#base64 ";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA1
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA1 = "http://www.w3.org/2000/09/xmldsig#sha1";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA256
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA256 = "http://www.w3.org/2001/04/xmlenc#sha256";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr SHA512
        /// </summary>
        public const System.String DIGEST_ALGORITHM_SHA512 = "http://www.w3.org/2001/04/xmlenc#sha512";

        /// <summary> Algorithmus fr Hashwerterstellung, Konstante fr RIPEMD160
        /// </summary>
        public const System.String DIGEST_ALGORITHM_RIPEMD160 = "http://www.w3.org/2001/04/xmlenc#ripemd160";

		/// <summary> Algorithmus fr symmetrische Verschlsselung Two-Key-Triple-DES (CBC-Mode)
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_TDES_CBC = "http://www.w3.org/2001/04/xmlenc#tripledes-cbc";

        /// <summary> Algorithmus fr symmetrische Verschlsselung Two-Key-Triple-DES (CBC-Mode), RSAManaged-Identifier
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_TDES_CBC_JCA_JCE = "DESede/CBC/PKCS5Padding";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-128
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES128 = "http://www.w3.org/2001/04/xmlenc#aes128-cbc";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-192
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES192 = "http://www.w3.org/2001/04/xmlenc#aes192-cbc";
		
		/// <summary> Algorithmus fr symmetrische Verschlsselung AES-256
		/// </summary>
		public const System.String SYMMETRIC_CIPHER_ALGORITHM_AES256 = "http://www.w3.org/2001/04/xmlenc#aes256-cbc";
		
		/// <summary> Algorithmus fr asymmetrische Verschlsselung RSAES-PKCS1-v1_5
		/// </summary>
		public const System.String ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5 = "http://www.w3.org/2001/04/xmlenc#rsa-1_5";

        /// <summary> Algorithmus fr asymmetrische Verschlsselung RSAES-PKCS1-v1_5, RSAManaged-Identifier
		/// </summary>
		public const System.String ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5_NET = "RSA/ECB/PKCS1Padding";
		
        /// <summary> Algorithmus fr asymmetrische Verschlsselung RSA-OAEP
		/// </summary>
  	    public const String ASYMMETRIC_CIPHER_ALGORITHM_RSA_OAEP = "http://www.w3.org/2009/xmlenc11#rsa-oaep";

        /// <summary> Algorithmus fr asymmetrische Verschlsselung RSAES-OAEP, RSAManaged-Identifier
		/// </summary>
        private const String ASYMMETRIC_CIPHER_ALGORITHM_RSA_OAEP_NET = "RSA/ECB/OAEPPadding";

        /// <summary> Algorithmus fr Maskengenerierung (RSA-OAEP) mit MGF1 und SHA-256
		/// </summary>
  	    public const String MASK_GENERATION_FUNCTION_1_SHA256 = "http://www.w3.org/2009/xmlenc11#mgf1sha256";
  	 
  	    /// <summary> Algorithmus fr Maskengenerierung (RSA-OAEP) mit MGF1 und SHA-512
        /// </summary>
        public const String MASK_GENERATION_FUNCTION_1_SHA512 = "http://www.w3.org/2009/xmlenc11#mgf1sha512";
 
		public const System.String TYPE_CONTENT = "http://www.w3.org/2001/04/xmlenc#Content";
		
		// Optional (wird nicht benutzt)
		/// <summary> Kanonisierung (optional)
		/// </summary>
		public const System.String CANONICALIZATION = "http://www.w3.org/TR/2001/REC-xml-c14n-20010315";
		public const System.String EXC_CANONICALIZATION = "http://www.w3.org/2001/10/xml-exc-c14n#";
		
		// Transforms
		/// <summary> XSLT-Transformation
		/// </summary>
		public const System.String TRANSFORM_XSLT = "http://www.w3.org/TR/1999/REC-xslt-19991116";
		
		/// <summary> Kanonisierung
		/// </summary>
		public const System.String TRANSFORM_CANONICALIZATION = "http://www.w3.org/TR/2001/REC-xml-c14n-20010315";
		
		/// <summary> Tranformer fr Base64-Decoder
		/// </summary>
		public const System.String TRANSFORM_BASE64 = "http://www.w3.org/2000/09/xmldsig#base64";

		static Constants()
		{
			NET_MAP = new System.Collections.Hashtable();
			{
                SupportClass.PutElement(NET_MAP, ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5, ASYMMETRIC_CIPHER_ALGORITHM_RSA_1_5_NET);
                SupportClass.PutElement(NET_MAP, ASYMMETRIC_CIPHER_ALGORITHM_RSA_OAEP, ASYMMETRIC_CIPHER_ALGORITHM_RSA_OAEP_NET);

                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA1, SIGNATURE_ALGORITHM_RSA_SHA1_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA256, SIGNATURE_ALGORITHM_RSA_SHA256_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_SHA512, SIGNATURE_ALGORITHM_RSA_SHA512_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_RIPEMD160, SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_RSA_RIPEMD160_RFC4051, SIGNATURE_ALGORITHM_RSA_RIPEMD160_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_ECDSA_SHA256, SIGNATURE_ALGORITHM_ECDSA_SHA256_NET);
                SupportClass.PutElement(NET_MAP, SIGNATURE_ALGORITHM_ECDSA_SHA512, SIGNATURE_ALGORITHM_ECDSA_SHA512_NET);

                SupportClass.PutElement(OUT_DATES, DIGEST_ALGORITHM_SHA1, new DateTime(2008, 7, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_SHA1, new DateTime(2008, 7, 1));
                SupportClass.PutElement(OUT_DATES, DIGEST_ALGORITHM_RIPEMD160, new DateTime(2011, 1, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_RIPEMD160, new DateTime(2011, 1, 1));
                SupportClass.PutElement(OUT_DATES, SIGNATURE_ALGORITHM_RSA_RIPEMD160_RFC4051, new DateTime(2011, 1, 1));
            }
		}
	}
}