namespace de.osci.osci12.common {

	using System;
	using de.osci.osci12;
	using de.osci.osci12.messagetypes;
	
	/// <summary> Diese Exception wird fr die in der OSCI 1.2 Transport-Spezifikation
	/// definierten Fehlermeldungen verwendet.
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class OSCIErrorException:OSCIException
	{
        private OSCIMessage message;
		public OSCIErrorException(System.String errorCode):base(errorCode)
		{
		}

        public OSCIErrorException(System.String errorCode, OSCIMessage message): base(errorCode)
        {
            this.message = message;
        }

        public OSCIMessage Message
        {
            get
            {
                return message;
            }
            set
            {
                message = value;
            }
        }
		
        

    
	}
}