namespace de.osci.osci12.common {

	using System;
	using de.osci.osci12;

	/// <summary>Diese Exception zeigt ein Problem bei Signaturvorgngen an.
	/// Die Bibliothek fat auch einige JCE/JCA-Exceptions hiermit zusammen, um 
	/// (aus Sicherheitsgrnden) keine detaillierten Informationen ber fehlgeschlagene
	/// Signierversuche zu liefern.
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	
	public class OSCISignatureException:OSCIException
	{
		public OSCISignatureException(System.String message):base(message)
		{
		}
		
		public OSCISignatureException(System.String message, System.String errorCode):base(message, errorCode)
		{
		}
	}
}