namespace de.osci.osci12.common {

	using System;
	
	/// <summary> Diese Exception zeigt eine der in der OSCI-Spezifikation
	/// definierten Fehlermeldungen auf Nachrichtenebene (faultcode soap:Client).
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class SoapClientException:OSCIException {
		
		/// <summary> Erzeugt ein SoapClientException-Objekt mit einem Fehlercode und erklrendem
		/// String als Message. Als Message-String wird der dem Code entsprechende Eintrag
		/// in der zum aktuellen default-Locale gehrenden Sprachdatei 
		/// (s. Package de.osci.osci12.extinterfaces.language) gesetzt.
		/// </summary>
		/// <param name="errorCode">errorCode
		/// </param>
		public SoapClientException(System.String errorCode):base(errorCode) {
		}

		/// <summary>Erzeugt ein SoapClientException-Objekt mit einem erklrenden String als
		/// Message und einem Fehlercode.
		/// </summary>
		/// <param name="faultstring">faultstring</param>
		/// <param name="oscicode">oscicode</param>
		public SoapClientException(String oscicode, String faultstring):base(faultstring, oscicode) {
		}
	}
}