namespace de.osci.osci12.common {

	using System;
	
	/// <summary> Diese Exception zeigt eine der in der OSCI-Spezifikation
	/// definierten Fehlermeldungen auf Nachrichtenebene (faultcode soap:Server).
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class SoapServerException:OSCIException {

		/// <summary> Erzeugt ein SoapServerException-Objekt mit einem erklrenden String und
		/// einem Fehlercode. Als Fehlercode kann jeder String verwendet werden, fr den
		/// ein entsprechender Eintrag in der zum gesetzten default-Locale gehrenden
		/// Sprachdatei (s. Package de.osci.osci12.extinterfaces.language) vorhanden ist.
		/// </summary>
		/// <param name="message">message
		/// </param>
		/// <param name="errorCode">errorCode
		/// </param>
		public SoapServerException(System.String code):base(code) {
		}

		/// <summary>Erzeugt ein SoapServerException-Objekt mit einem erklrenden String als
		/// Message und einem Fehlercode.
		/// </summary>
		/// <param name="faultstring">Fehlertext</param>
		/// <param name="oscicode">oscicode</param>
		public SoapServerException(String oscicode, String faultstring):base(faultstring, oscicode) {
		}
	}
}