namespace de.osci.osci12.encryption {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.signature;
	
	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class EncryptedType 
	{

		virtual public System.String Id {
			get {
				return id;
			}
			
			set {
				this.id = value;
			}	
		}

		virtual public System.String Type {
			get {
				return type;
			}	

			set {
				this.type = value;
			}
		}

		virtual public System.String Encoding {
			get {
				return encoding;
			}
			
			set {
				this.encoding = value;
			}	
		}

		virtual public System.String MimeType {
			get {
				return mimeType;
			}
			
			set {
				this.mimeType = value;
			}	
		}

		virtual public System.String EncryptionMethodAlgorithm {
			get {
				return encryptionMethodAlgorithm;
			}
			
			set {
				this.encryptionMethodAlgorithm = value;
			}	
		}

		virtual public EncryptionProperties EncryptionProperties {
			get {
				return encryptionProperties;
			}
			
			set {
				this.encryptionProperties = value;
			}		
		}

		virtual public CipherData CipherData {
			get {
				return cipherData;
			}
			
			set {
				this.cipherData = value;
			}	
		}

		virtual public KeyInfo KeyInfo {
			get {
				return keyInfo;
			}
			
			set {
				if (value == null) {
					log.warn("KeyInfo durf nicht null sein.");
				}
				this.keyInfo = value;
			}	
		}

		private static Log log;
		
		/// <summary>ID dieses Elements.
		/// </summary>
		private System.String id;

		/// <summary>Type.
		/// </summary>
		private System.String type;

		/// <summary>Encoding. 
		/// </summary>
		private System.String encoding;

		/// <summary>MimeType z.B. text/xml. 
		/// </summary>
		private System.String mimeType;

		/// <summary>Algorithmus der Verschlsselung. Z.B. DES fuer Nachricht oder RSA fuer KEY. 
		/// </summary>
		private System.String encryptionMethodAlgorithm;

		/// <summary>Weitere Eigenschaften der Verschlsselung. Noch nicht Impl. 
		/// </summary>
		private EncryptionProperties encryptionProperties;

		/// <summary>CipherData Element. 
		/// </summary>
		private CipherData cipherData;

		/// <summary>Das KeyInfo Element. 
		/// </summary>
		private KeyInfo keyInfo;
		
		public EncryptedType() {
		}
		
		static EncryptedType() {
			log = LogFactory.getLog(typeof(EncryptedType));
		}
	}
}