namespace de.osci.osci12.encryption {

	using System;
	using de.osci.osci12;

	/// <exclude/>
	/// <summary> Diese Exception zeigt ein Problem bei Ver- oder Entschlsselungsvorgngen
	/// an. Die Bibliothek fat auch einige JCE/JCA-Exceptions hiermit zusammen, um (aus
	/// Sicherheitsgrnden) keine detaillierten Informationen ber fehlgeschlagene
	/// Entschlsselungsversuche zu liefern.
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class OSCICipherException:OSCIException 
	{

		public OSCICipherException(System.String errorCode):base(errorCode) {
		}
		public OSCICipherException(String message, String errorCode):base(message, errorCode) { 
		}    
	} 
}
