namespace de.osci.osci12.extinterfaces {

	using System;
	
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public struct ProgressEventHandlerI_Fields{
		public readonly static int SEND_MESSAGE = 0;
		public readonly static int RECEIVE_MESSAGE = 1;
	}

	/// <summary>Anwendungen knnen eine Implementierung dieser Schnittstelle im DialogHandler-Objekt
	/// einer Kommunikation setzen, ber das die Bibliothek Informationen ber die Durchfhrung
	/// von Operationen liefert. Z.Zt. bietet die Bibliothek nur eine minimale Untersttzung
	/// dieser Schnittstelle, beispielsweise ohne Informationen ber den prozentualen Fortschritt
	/// einer Operation.
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	/// <seealso cref="de.osci.osci12.common.DialogHandler.ProgressEventHandler()">
	/// </seealso>
	public interface ProgressEventHandlerI {

		/// <summary> Liefert eine Versionsnummer.
		/// </summary>
		/// <value> Versionsnummer
		/// </value>
		System.String Version {
			get;
		}

		/// <summary> Liefert den Namen des Herstellers.
		/// </summary>
		/// <value> Herstellername
		/// </value>
		System.String Vendor {
			get;
		}

		/// <summary> Wird aufgerufen, sobald langwierige Vorgnge in der Bibliothek der
		/// Applikation mitgeteilt werden sollen.
		/// </summary>
		/// <param name="type">Art der Nachticht
		/// </param>
		/// <param name="param">Text des Fortschrittsevents
		/// </param>
		/// <param name="percent">Fortschritt in Prozent
		/// </param>
		void  event_Renamed(int type, System.String param, int percent);
	}
}