using System;
using org.apache.commons.logging;

namespace de.osci.osci12.messageparts
{
	/// <summary><H4>FeedbackObject</H4>
	/// <p>Diese Klasse reprsentiert die Feedback-Eintrge einer OSCIResponseTo-Nachricht</p>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class FeedbackObject
	{
		private static Log log = LogFactory.getLog(typeof(FeedbackObject));
		private String lang, code, text;

		internal FeedbackObject(String[] feedback) {
			lang = feedback[0];
			code = feedback[1];
			text = feedback[2];
		}

		/// <summary> Liefert die Sprachkrzel der Feedbackeintrge (de, en...).
		/// </summary>
		/// <value> Sprachkrzel
		/// </value>
		public String Language {get{return lang;}}

		/// <summary> Liefert die Rckmeldecodes der Feedbackeintrge.
		/// </summary>
		/// <value> Rckmeldecodes
		/// </value>
		public String Code {get{return code;}}

		/// <summary> Liefert die Texte der Feedbackeintrge.
		/// </summary>
		/// <value> Texte
		/// </value>
		public String Text {get{return text;}}
	}
}
