namespace de.osci.osci12.messagetypes {

	using System;
	using de.osci.osci12.common;
	using de.osci.osci12.roles;
	using de.osci.osci12.encryption;
	using de.osci.osci12;
	using org.xml.sax;

	/// <summary> Die Klasse ist der Einrittspunkt fr Nachrichten, die bei einem passiven Empfnger
	/// eingehen.
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	class StoredMessageParser:de.osci.osci12.messagetypes.IncomingMSGParser {

		internal override OSCIEnvelopeBuilder getParser(org.xml.sax.XMLReader reader, DialogHandler dh) {
			return new StoredEnvelopeBuilder(reader);
		}
		
		public virtual StoredMessage parseStream(System.IO.Stream input) {
			try {
				return (StoredMessage) base.parseStream(input, null, true, null);
			} catch (OSCISignatureException ex) {
				throw new OSCIErrorException("9601");
			}
		}
	}
}