namespace de.osci.osci12.signature {

	using System;
	
	/// <exclude/>
	/// <summary> Subklassen dieser Klasse knnen implementiert werden, um Transformationen
	/// fr die Signaturen von ContentContainer-Objekten zu
	/// 
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public abstract class Transform 
	{
 
		virtual public System.String TransformAlgorithmId {
			get {
				return transformAlgorithm;
			}
			set {
				this.transformAlgorithm = transformAlgorithm;
			}
		}

		protected internal System.String transformAlgorithm;
		
		/// <summary> Creates a new Transform object.
		/// </summary>
		public Transform(System.String transformAlgorithm) {
			this.transformAlgorithm = transformAlgorithm;
		}

		public abstract byte[] update(byte[] b, int off, int len);

		public abstract byte[] doFinal(byte[] in_Renamed);
		
	}
}