namespace de.osci.osci12.soapheader {
	using System;
	using org.apache.commons.logging;
	using org.xml.sax;
	using de.osci.osci12.common;
	using de.osci.osci12.messageparts;
	using de.osci.osci12.messagetypes;
	using de.osci.osci12.roles;

	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class ControlBlockHBuilder:de.osci.osci12.messageparts.MessagePartParser 
	{

		/// <summary> Gets the controlBlock attribute of the ControlBlockHBuilder object
		/// </summary>
		/// <value>The controlBlock value
		/// </value>
   
		virtual public ControlBlockH ControlBlock 
		{
			get {
				return cb;
			}
			
		}
		new private static Log log;
		
		//  Array steht fr {Response,challenge,conversationID,SequenzNumber}
		private int[] check;
		
		private ControlBlockH cb = null;
		
		/// <summary> Constructor for the ControlBlockHBuilder object
		/// </summary>
		/// <param name="parent">
		/// </param>
		/// <param name="atts">
		/// </param>
		/// <param name="check">
		/// </param>
		public ControlBlockHBuilder(OSCIMessageBuilder parent, Attributes atts, int[] check):base(parent) {
			this.check = check;
			
			cb = new ControlBlockH();
			if (atts.getValue("Id") != null) {
				cb.RefID=atts.getValue("Id");
			}
			cb.ConversationID=atts.getValue("ConversationId");
			//OSCIMessage msg = parent.OSCIMessage; 
			cb.setNSPrefixes(msg); 
			if (atts.getValue("SequenceNumber") != null) 
			{
				cb.SequenceNumber=System.Int32.Parse(atts.getValue("SequenceNumber"));
			}
		}
		
		/// <summary> 
		/// </summary>
		/// <param name="uri">
		/// </param>
		/// <param name="localName">
		/// </param>
		/// <param name="qName">
		/// </param>
		/// <param name="attributes">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public override void  startElement(System.String uri, System.String localName, System.String qName, Attributes attributes) {
			log.debug("init ControlBlock  Element: " + localName);
			if (localName.Equals("Response") && uri.Equals(OSCI_XMLNS)
				|| localName.Equals("Challenge")&& uri.Equals(OSCI_XMLNS)) {
				currentElement = new System.Text.StringBuilder();
			}
			else {
				throw new org.xml.sax.SAXException("Unerwartetes Element im ControlBlock: " + localName);
			}
		}
		
		/// <summary> 
		/// </summary>
		/// <param name="uri">
		/// </param>
		/// <param name="localName">
		/// </param>
		/// <param name="qName">
		/// </param>
		/// <exception cref="org.xml.sax.SAXException">
		/// </exception>
		public override void  endElement(System.String uri, System.String localName, System.String qName) {
			log.debug("End-Element Von ControlBlock: " + localName);
			if (localName.Equals("Response")&& uri.Equals(OSCI_XMLNS)) {
				cb.Response = currentElement.ToString();
			}
			else if (localName.Equals("Challenge")&& uri.Equals(OSCI_XMLNS)) {
				cb.Challenge = currentElement.ToString();
			}
			else if (localName.ToUpper().Equals("ControlBlock".ToUpper())&& uri.Equals(OSCI_XMLNS)) {
				if ((check[0] == 1) && (cb.Response == null)) {
					throw new org.xml.sax.SAXException("Erforderlicher Response-Wert fr das Element ControlBlock nicht vorhanden!");
				}
				else if ((check[0] == 0) && (cb.Response != null)) {
					throw new org.xml.sax.SAXException("Nicht erlaubter Response-Wert fr das Element ControlBlock vorhanden!");
				}
					
				if ((check[1] == 1) && (cb.Challenge == null)) {
					throw new org.xml.sax.SAXException("Erforderlicher Challenge-Wert fr das Element ControlBlock nicht vorhanden !");
				}
				else if ((check[1] == 0) && (cb.Challenge != null)) {
					log.debug("\n\n " + check[0] + check[1] + check[2] + check[3]);
					throw new org.xml.sax.SAXException("Nicht erlaubter Challenge-Wert fr das Element ControlBlock vorhanden !");
				}
					
				if ((check[2] == 1) && (cb.ConversationID == null)) {
					throw new OSCIErrorException("9802", msg);
				}
				else if ((check[2] == 0) && (cb.ConversationID != null)) {
					throw new org.xml.sax.SAXException("Nicht erlaubte Conversation-Id fr das Element ControlBlock vorhanden !");
				}
					
				if ((check[3] == 1) && (cb.SequenceNumber == - 1)) {
					throw new org.xml.sax.SAXException("Erforderliche Sequence-Number fr das Element ControlBlock nicht vorhanden !");
				}
				else if ((check[3] == 0) && (cb.SequenceNumber != - 1)) {
					throw new org.xml.sax.SAXException("Nicht erlaubte Sequence-Number fr das Element ControlBlock vorhanden !");
				}
				DialogHandler dh = msg.dialogHandler;
				if ((check[0] & check[1] & check[2] & check[3]) < 0) {
					dh = new DialogHandler((Originator) null, new Intermed(null, null, null),
						(de.osci.osci12.extinterfaces.TransportI) null);
					dh.Controlblock.ConversationID=cb.ConversationID;
					dh.Controlblock.Challenge=cb.Challenge;
					dh.Controlblock.Response=cb.Response;
					dh.Controlblock.SequenceNumber=cb.SequenceNumber;
				}
				else {
					if (dh == null) {
					if (cb.ConversationID != null) {
						dh = DialogHandler.findDialog(cb);
					}
					else {
						dh = new DialogHandler((Originator) null, (Intermed) null, (de.osci.osci12.extinterfaces.TransportI) null);
						log.debug("\n!!!!!!NEUER CB!!!!!!!!!!\n" + cb.SequenceNumber);
					}
				}
				// An dieser Stelle wird die Sequenz-Nummer auf der Supplierseite hochgezhlt
				if (msg is OSCIRequest) {
					if (cb.SequenceNumber > - 1) {
						dh.Controlblock.SequenceNumber = dh.Controlblock.SequenceNumber + 1;
					}
				}
				dh.checkControlBlock(cb);	
			}
			msg.DialogHandler = dh;
			msg.controlBlock = cb;
			xmlReader.setContentHandler(this.parentHandler);
			}
			currentElement = null;
		}
		static ControlBlockHBuilder() {
			log = LogFactory.getLog(typeof(ControlBlockHBuilder));
		}
	}
}