namespace de.osci.osci12.soapheader {

	using System;
	using System.IO;
	using org.apache.commons.logging;
	using de.osci.osci12.common;
	using de.osci.osci12.dotcommon;

	/// <exclude/>
	public class CustomHeader : HeaderEntry 
	{

		private static Log log = LogFactory.getLog(typeof(CustomHeader));
		private String data;

		public CustomHeader(String data) {
			int i = data.IndexOf(" Id=");
			if (i == -1) i = data.IndexOf(" Id =");
			if ((i == -1) || (i > data.IndexOf('>')))
				throw new Exception(de.osci.osci12.common.DialogHandler.text.getString("missing_entry")+": Id");
			else i = data.IndexOf("\"", i) + 1;
			String h=data.Substring(i, data.IndexOf('\"', i)-i);
			RefID=h;
			this.data = data;
		}


		public String getData() {
			return data;
		}

		public override void writeXML(Stream out0) {
			if (log.DebugEnabled) log.debug("Custom RefID: " + RefID);
			MoreSupport.ToStream(out0,data,Constants.CHAR_ENCODING);
		}
	}
}
