namespace de.osci.osci12.soapheader {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.common;

	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: P. Ricklefs, N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class DesiredLanguagesH:HeaderEntry 
	{

		virtual public System.String LanguageList {
			get {
				return languageList;
			}
			
		}

		new private static Log log;

		/// <summary>Liste der Sprachen im Format de,fr 
		/// </summary>
		private System.String languageList;
		
		/// <summary> Creates a new DesiredLanguageH object.
		/// </summary>
		/// <param name="languageList">
		/// </param>
		public DesiredLanguagesH(System.String languageList) {
			this.languageList = languageList;
		}
		
		public override void  writeXML(System.IO.Stream out_Renamed) {
			if (tmpBuffer != null) {
				byte[] temp_byteArray;
				temp_byteArray = tmpBuffer;
				out_Renamed.Write(temp_byteArray, 0, temp_byteArray.Length);;;;
			}
			else {
    MoreSupport.ToStream(out_Renamed,"<" + osciNSPrefix +":DesiredLanguages",Constants.CHAR_ENCODING);
    out_Renamed.Write(ns,0,ns.Length);
    MoreSupport.ToStream(out_Renamed," Id=\"desiredlanguages\" LanguagesList=\"" + languageList,Constants.CHAR_ENCODING);
			//	MoreSupport.ToStream(out_Renamed,"<osci:DesiredLanguages Id=\"desiredlanguages\" LanguagesList=\"" + languageList + 
MoreSupport.ToStream(out_Renamed,"\" " + soapNSPrefix + ":actor=\"http://schemas.xmlsoap.org/soap/actor/next\" " + soapNSPrefix + ":mustUnderstand=\"1\"></" + osciNSPrefix +":DesiredLanguages>",Constants.CHAR_ENCODING);
			}
		}
		static DesiredLanguagesH() {
			log = LogFactory.getLog(typeof(DesiredLanguagesH));
		}
	}
}