namespace de.osci.osci12.soapheader {

	using System;
	using org.apache.commons.logging;
	using de.osci.osci12.common;
	using de.osci.osci12.roles;
	
	/// <exclude/>
	/// <summary>
	/// <p>Copyright  2014 Freie Hansestadt Bremen</p>
	/// <p>Erstellt von Governikus GmbH & Co.  KG

	/// <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
	/// freie Softwarebibliotheken genutzt werden.</p><p>Die Lizenzbestimmungen knnen
	/// unter der URL www.osci.de abgerufen oder bei der
	/// Koordinierungsstelle fr IT-Standards (KoSIT), Schillerstr. 1,
	/// 28195 Bremen schriftlich angefordert werden.</p>
	/// 
	/// <p>Author: N. Bngener</p> 
	/// <p>Version: 1.6</p>
	/// </summary>
	public class IntermediaryCertificatesH:CertificateH 
	{

		virtual public Intermed CipherCertificateIntermediary {
			get {
				return cipherCertificateIntermediary;
			}
			set {
				log.debug("CipherCertificate Intermed wurde gesetzt");
				Object dumm=value.CipherCertificate;
				this.cipherCertificateIntermediary = value;
			}	
		}

		virtual public Intermed SignatureCertificateIntermediary {
			get {
				return signaturCertificateIntermediary;
			}			
			set {
				Object dumm=value.SignatureCertificate;
				this.signaturCertificateIntermediary = value;
			}	
		}
		
		new private static Log log;
		private Intermed signaturCertificateIntermediary;
		private Intermed cipherCertificateIntermediary;

		public override void  writeXML(System.IO.Stream out_Renamed) {
			if (tmpBuffer != null) {
				byte[] temp_byteArray;
				temp_byteArray = tmpBuffer;
				out_Renamed.Write(temp_byteArray, 0, temp_byteArray.Length);;;;
			} else {
   MoreSupport.ToStream(out_Renamed,"<" + osciNSPrefix +":IntermediaryCertificates",Constants.CHAR_ENCODING);
   out_Renamed.Write(ns,0,ns.Length);
   MoreSupport.ToStream(out_Renamed," Id=\"intermediarycertificates\"  " + soapNSPrefix + ":actor=\"http://www.w3.org/2001/12/soap-envelope/actor/none\"  " + soapNSPrefix + ":mustUnderstand=\"1\">",Constants.CHAR_ENCODING);
				
				if (cipherCertificateIntermediary != null) {
					addCipherCertificate(cipherCertificateIntermediary, out_Renamed);
				}
				if (signaturCertificateIntermediary != null) {
					addSignatureCertificate(signaturCertificateIntermediary, out_Renamed);
				}
				MoreSupport.ToStream(out_Renamed,"</" + osciNSPrefix +":IntermediaryCertificates>",Constants.CHAR_ENCODING);
			}
		}
		
		static IntermediaryCertificatesH() {
			log = LogFactory.getLog(typeof(IntermediaryCertificatesH));
		}
	}
}